# Модуль интеграции Dreamkas для OpenCart 3.\*

## Содержимое репозитория

- `./dreamkas-opencart3.ocmod/` - директория с исходным кодом модифицированного мной модуля
- `./dreamkas-opencart3.ocmod.zip` - модифицированный модуль, готовый к установке
- `./dreamkas-f opencart.ocmod.zip` - исходный модуль для OpenCart 2.3, на котором основана данная модификация

## Описание

Модификация тестировалась на **OpenCart 3.0.2.0**.
Модуль устанавливается, удаляется, настройки сохраняются, читаются.
Судя по отзывам ([первый](http://blog.anthonyaxenov.ru/2018/05/09/%d0%bc%d0%be%d0%b4%d1%83%d0%bb%d1%8c-%d0%b8%d0%bd%d1%82%d0%b5%d0%b3%d1%80%d0%b0%d1%86%d0%b8%d0%b8-dreamkas-%d0%b4%d0%bb%d1%8f-opencart-3-0-2-0/#comment-103), [второй](https://help.dreamkas.ru/hc/ru/articles/115005504689-%D0%9F%D0%BE%D0%B4%D0%BA%D0%BB%D1%8E%D1%87%D0%B8%D1%82%D1%8C-%D0%BA%D0%B0%D1%81%D1%81%D1%83-%D0%BA-OpenCart)), полученный модуль в целом работает, за исключением одного момента: не отображаются статусы фискализации.

У меня лично нет возможности полноценно проверить насколько качественно работает этот модуль: для этого нужны реальные заказы и покупки.
Проект, в рамках которого я работал над этим модулем, я больше не поддерживаю.

Вся основная логика модуля прописана здесь:
`upload/catalog/controller/extension/module/dreamkas.php`

Этот файл я не трогал.
Я лишь восстановил возможность установить, удалить и настроить модуль.

## Краткая информация об изменениях

Основано на модуле _[dreamkas-f opencart.ocmod.zip](https://help.dreamkas.ru/hc/ru/article_attachments/115010763145/dreamkas-f_opencart.ocmod.zip)_.

Этот архив предоставляется самими сотрудниками Dreamkas.
Он включен в репозиторий для истории.

Ниже вкратце описаны мои правки, но чтобы узнать детальные изменения, то можете заморочиться с diff-ами.

1. Шаблон (`upload/admin/view/template/extension/module/dreamkas.twig`):
   1. переписан с языка php на язык шаблонизатора Twig
   2. изменено расширение с .tpl на .twig
2. Страница настроек:
   1. удалены большие куски закомментированного и нерабочего (?) кода
   2. исправлено получение списка установленных платёжных систем в настройках
   3. форматирование кода (`upload/admin/controller/extension/module/dreamkas.php`)

## Полезные ссылки

1. [История появления этой модификации](http://blog.anthonyaxenov.ru/2018/05/09/модуль-интеграции-dreamkas-для-opencart-3-0-2-0)
2. [Открытая документация к Dreamkas API](http://kabinet.docs.apiary.io)
3. [Как подключить интернет-магазин к кассе через Кабинет?](https://help.dreamkas.ru/hc/ru/articles/115005007709)
4. [Подключить кассу к OpenCart](https://help.dreamkas.ru/hc/ru/articles/115005504689-%D0%9F%D0%BE%D0%B4%D0%BA%D0%BB%D1%8E%D1%87%D0%B8%D1%82%D1%8C-%D0%BA%D0%B0%D1%81%D1%81%D1%83-%D0%BA-OpenCart)
5. Групповой чат для разработчиков в Telegram: [@apidreamkas](https://t.me/apidreamkas)

## Поддержка

**ПОЖАЛУЙСТА, НЕ ПРОСИТЕ У МЕНЯ ПОМОЩИ!**

Я НЕ ДАЮ НИКАКИХ ГАРАНТИЙ ЕГО РАБОТОСПОСОБНОСТИ И НЕ ПРЕДОСТАВЛЯЮ ПОДДЕРЖКУ.

ЛЮБЫЕ МАНИПУЛЯЦИИ С МОДУЛЕМ — НА ВАШ СТРАХ И РИСК.

Я вижу, что люди используют мою модификацию. Но у меня нет никакого интереса и необходимости в этом. Многие вещи об OpenCart, продуктах Dreamkas и этом модуле уже забыты. Поэтому, и поскольку проект изначально не мой, лично я развивать его точно не буду.

Этот репозиторий появился только потому, что на фоне наплевательского отношения со стороны Dreamkas мне случайно удалось сделать из совсем нерабочей вещи почти рабочую.

Берите и используйте. Не работает — штош. Если у вас есть какие-то доработки — pull-requests are welcome. Но лучше сделайте форк этого репозитория и развивайте проект дальше самостоятельно.

## Лицензия

[<img src="http://www.wtfpl.net/wp-content/uploads/2012/12/wtfpl-badge-1.png" alt="WTFPL" />](LICENSE)

Аргументирую:
1. Компания Dreamkas распространяет свои модули без какой-либо лицензии.
2. [Код этих модулей не был написан компанией Dreamkas](https://help.dreamkas.ru/hc/ru/articles/115005504689/comments/360000156078), а в этом случае исключительные авторские права Dreamkas на этот код должны быть оговорены только в рамках правовых отношений с подрядчиком.
3. Этот модуль находится в открытом доступе в разделе поддержки Dreamkas. Ни [лицензионное соглашение](https://dreamkas.ru/content/kluch-oferta.pdf), ни [договор-оферта](https://dreamkas.ru/content/dogovor-oferta-clients.pdf), публично представленные на сайте Dreamkas:
   * не содержат условий использования, изменения и распространения пользователями этого модуля;
   * неприменимы для этого случая (см. п. 2)

Исходя из этого, делаю выводы:
1. Компания Dreamkas никоим образом не заявляет о своих правах на код модуля, об условиях его использования, распространения и изменения. Поэтому я вправе сделать это самостоятельно, так как код был изменён мной.
2. **[Лицензия WTFPL v2](LICENSE)** как никакая другая лучше подходит для этого случая.

Я готов обсудить вопросы лицензии и изменить условия, если вам есть что сказать по существу.
